# Copyright (C) 2023 Tastitalia

DESCRIPTION = "Tastitalia i.MX Cortex M4/M7 Firmware Demos"
LICENSE = "CLOSED"
SECTION = "BSP"

DEPENDS = "cmake-native"

inherit deploy

addtask deploy after do_compile

SRCREV:mx8mm-nxp-bsp= "67ccec7f430195ae94906c098c0d66ed81832f0e"
SRCREV:mx8mp-nxp-bsp= "4d889576fac2489bcee303e35ac731a7df52dd9c"

SRC_URI:mx8mm-nxp-bsp= "git://gitlab.tastitalia.com/tastitalia-mpu-arm/yocto/firmware/imx8mm_m4_firmware.git;protocol=https;branch=main \
                        https://developer.arm.com/-/media/Files/downloads/gnu-rm/10.3-2021.10/gcc-arm-none-eabi-10.3-2021.10-x86_64-linux.tar.bz2;name=gcc-arm-none-eabi-10.3-2021.10"

SRC_URI:mx8mp-nxp-bsp= "git://gitlab.tastitalia.com/tastitalia-mpu-arm/yocto/firmware/imx8mp_m7_firmware.git;protocol=https;branch=main \
                        https://developer.arm.com/-/media/Files/downloads/gnu-rm/10.3-2021.10/gcc-arm-none-eabi-10.3-2021.10-x86_64-linux.tar.bz2;name=gcc-arm-none-eabi-10.3-2021.10"

SRC_URI[gcc-arm-none-eabi-10.3-2021.10.sha256sum] = "97dbb4f019ad1650b732faffcc881689cedc14e2b7ee863d390e0a41ef16c9a3"

S = "${WORKDIR}/git"

EXTRA_OECMAKE= "--install-prefix /git"

MCU_BIN_NAME = ""
MCU_BIN_NAME:mx8mm-nxp-bsp = "imx8mm_m4_firmware.bin"
MCU_BIN_NAME:mx8mp-nxp-bsp = "imx8mp_m7_firmware.bin"

# do_configure() {
#     cd ${S}
#     export ARMGCC_DIR="${WORKDIR}/gcc-arm-none-eabi-10.3-2021.10"
#     cmake -DCMAKE_TOOLCHAIN_FILE="armgcc.cmake" -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=debug
# }

do_compile() {
    cd ${S}
    export ARMGCC_DIR="${WORKDIR}/gcc-arm-none-eabi-10.3-2021.10"
    ./build_debug.sh
}

do_install() {
    install -d ${D}/boot/
    install -m 644 ${S}/debug/${MCU_BIN_NAME} ${D}/boot/fw.bin
}

do_deploy() {
    install -m 644 ${S}/debug/${MCU_BIN_NAME} ${DEPLOYDIR}/fw.bin
}


FILES:${PN} = " \
    /boot \
"

COMPATIBLE_MACHINE = "(mx6|mx8)"
