DESCRIPTION = "Tastitalia base image"
LICENSE = "MIT"


require ../../meta-imx/meta-sdk/recipes-fsl/images/imx-image-multimedia.bb
# set custom admin password (e.g "newpswd") for root user
#inherit extrausers
#EXTRA_USERS_PARAMS = "usermod -P newpswd root;"

# include QtGraphicalEffects library in SMARC image
# QT5_IMAGE += " qtgraphicaleffects-qmlplugins "

IMAGE_INSTALL:remove = " docker"

IMAGE_INSTALL:append = " \
    chromium-ozone-wayland \
    ntpdate \
    dialog \
    rsync \
    ntp \
    gattlib \
    font-system \
    gattd \
    lshw \
    libdrm \
    weston \
    wayland-utils \
    imx8-brcm \
    linux-firmware-bcm43430 \
	linux-firmware \
    quectel-cm \
    install-script \
    cantest \
    serialtools \
    "

IMAGE_INSTALL:append:mx8 = " mcu-tastitalia"

ROOTFS_POSTPROCESS_COMMAND:append:mx8-nxp-bsp = "fix_bcm43430;"

fix_bcm43430() { 
  cd ${IMAGE_ROOTFS}/lib/firmware/brcm
  ln -sf brcmfmac43430-sdio.bin brcmfmac43430-sdio.tas,imx8.bin
}

ROOTFS_POSTPROCESS_COMMAND:append = "install_chromium; "
ROOTFS_POSTPROCESS_COMMAND:append:tasv8mp = "install_chromium_tasv8mp; "

install_chromium() {
    if ! grep -q "icon=/usr/share/icons/hicolor/24x24/apps/chromium.png" ${IMAGE_ROOTFS}${sysconfdir}/xdg/weston/weston.ini
    then
       printf "\n[launcher]\nicon=/usr/share/icons/hicolor/24x24/apps/chromium.png\npath=/usr/bin/chromium --no-sandbox\n\n[launcher]\nicon=/usr/share/weston/terminal.png\npath=/usr/bin/weston-terminal" >> ${IMAGE_ROOTFS}${sysconfdir}/xdg/weston/weston.ini
    fi
    if ! grep -q "HOME=/home/root/" ${IMAGE_ROOTFS}${sysconfdir}/default/weston
    then
        printf "\nHOME=/home/root/\nQT_QPA_PLATFORM=wayland" >> ${IMAGE_ROOTFS}${sysconfdir}/default/weston
    fi
}

ROOTFS_POSTPROCESS_COMMAND:append:mx8mm10 = "flip_display; "

ROOTFS_POSTPROCESS_COMMAND:append:mx8mm10 = "flip_display; "
ROOTFS_POSTPROCESS_COMMAND:append:mx8mm2g10 = "flip_display; "
ROOTFS_POSTPROCESS_COMMAND:append:mx8mp10 = "flip_display; "
ROOTFS_POSTPROCESS_COMMAND:append:mx8mp10sd = "flip_display; "
ROOTFS_POSTPROCESS_COMMAND:append:tasv8mp = "flip_display; "
ROOTFS_POSTPROCESS_COMMAND:append:tasv8mp = "add_audio; "

flip_display() {
    sed -i 's/#transform=rotate-180/transform=rotate-180/g' ${IMAGE_ROOTFS}${sysconfdir}/xdg/weston/weston.ini
}

add_audio() {
    sed -i 's/--no-sandbox/--alsa-output-device="sysdefault" --no-sandbox/g' ${IMAGE_ROOTFS}${sysconfdir}/xdg/weston/weston.ini
}


