# Copyright 2018-2021 NXP
# Released under the MIT license (see COPYING.MIT for the terms)

DESCRIPTION = "Tastitalia lvgl image"

inherit core-image

IMAGE_FEATURES += " \
    debug-tweaks \
    tools-profile \
    tools-sdk \
    package-management \
    splash \
    nfs-server \
    tools-debug \
    ssh-server-dropbear \
    hwcodecs \
"

SDKIMAGE_FEATURES:append = " \
    staticdev-pkgs \
"

IMAGE_INSTALL += " \
    ${@bb.utils.contains('DISTRO_FEATURES', 'x11 wayland', 'weston-xwayland xterm', '', d)} \
    imx-test \
    firmwared \
    packagegroup-imx-core-tools \
    packagegroup-imx-security \
    curl \
    ${CLINFO} \
    dialog \
    rsync \
    gattlib \
    font-system \
    gattd \
    lshw \
    wayland-utils \
    linux-firmware \
    quectel-cm \
    install-script \
    lvgl-dev \
    lvgl-demos-dev \
    lvgl-examples-dev \
    lv-drivers-dev \
    libxkbcommon-dev \
    imx8-brcm \
    linux-firmware-bcm43430 \
    linux-firmware \
    quectel-cm \
    install-script \
"

IMAGE_INSTALL:append:mx8 = " mcu-tastitalia"

ROOTFS_POSTPROCESS_COMMAND:append:mx8-nxp-bsp = "fix_bcm43430;"

fix_bcm43430() {
  cd ${IMAGE_ROOTFS}/lib/firmware/brcm
  ln -sf brcmfmac43430-sdio.bin brcmfmac43430-sdio.tas,imx8.bin
}

CLINFO              ?= ""
CLINFO:imxgpu        = "clinfo"
CLINFO:mx8mm-nxp-bsp = ""
CLINFO:mx7-nxp-bsp   = ""

ROOTFS_POSTPROCESS_COMMAND:append:mx8-nxp-bsp = "fix_bcm43430;"

fix_bcm43430() {
  cd ${IMAGE_ROOTFS}/lib/firmware/brcm
  ln -sf brcmfmac43430-sdio.bin brcmfmac43430-sdio.tas,imx8.bin
}

export IMAGE_BASENAME = "tastitalia-lvgl-image"
