#!/bin/bash

#BOARD=$( cut -d = -f 7 <<< cat /proc/cmdline )
BOARD=$( rev <<< cat /proc/cmdline | cut -d '=' -f 1 | rev )
echo ""
echo "Starting flashing eMMC for ${BOARD} board"

echo ""
echo "#####################################################################"
echo "#                                                                   #"
echo "#                       Deleting eMMC partitions                    #"
echo "#                                                                   #"
echo "#####################################################################"
echo ""

#Delete partitions
umount /run/media/*
echo 0 > /sys/block/mmcblk2boot0/force_ro 
sync
dd if=/dev/zero of=/dev/mmcblk2 bs=1M count=500 conv=fsync status=progress
sync
sleep 0.5

echo ""
echo "#####################################################################"
echo "#                                                                   #"
echo "#                          Flashing U-Boot                          #"
echo "#                                                                   #"
echo "#####################################################################"
echo ""

#Flash U-boot
if [[ "$BOARD" == *"tasd8mm"* ]]; then
        dd if=/dev/mmcblk0 of=/dev/mmcblk2boot0 bs=1k skip=33 seek=33 count=4000 conv=fsync
elif [[ "$BOARD" == *"tasd8mp"* ]]; then
        dd if=/dev/mmcblk1 of=/dev/mmcblk2boot0 bs=1k skip=32 count=4000 conv=fsync
elif [[ "$BOARD" == *"tasc8mp"* ]]; then
        dd if=/dev/mmcblk1 of=/dev/mmcblk2 bs=1k skip=32 seek=32 count=4000 conv=fsync
elif [[ "$BOARD" == *"tasv8mp"* ]]; then
        dd if=/dev/mmcblk1 of=/dev/mmcblk2 bs=1k skip=32 seek=32 count=4000 conv=fsync
else
        echo "Error: board ${BOARD} not found."
        echo 1 > /sys/block/mmcblk2boot0/force_ro
        exit 1
fi
sync
echo 1 > /sys/block/mmcblk2boot0/force_ro
sync

echo ""
echo "#####################################################################"
echo "#                                                                   #"
echo "#                        Creating partitions                        #"
echo "#                                                                   #"
echo "#####################################################################"
echo ""

#Create partitions
umount /run/media/*
sync
echo -e "n\np\n1\n16384\n186775\nw" | fdisk /dev/mmcblk2
sleep 1
echo -e "n\np\n2\n186776\n\nw" | fdisk /dev/mmcblk2
sync
mkfs.fat /dev/mmcblk2p1
mkfs.ext4 /dev/mmcblk2p2
sleep 1

echo ""
echo "#####################################################################"
echo "#                                                                   #"
echo "#                        Copying File System                        #"
echo "#                                                                   #"
echo "#             It can take few minutes, time for a coffee            #"
echo "#                                                                   #"
echo "#####################################################################"
echo ""

#Copy files
umount /run/media/*
rm -rf /mnt2
mkdir /mnt2

if [[ "$BOARD" == *"tasd8mm"* ]]; then                                                     
	mount /dev/mmcblk0p2 /mnt/
elif [[ "$BOARD" == *"tasd8mp"* ]]; then                                                   
	mount /dev/mmcblk1p2 /mnt/
elif [[ "$BOARD" == *"tasc8mp"* ]]; then                                                   
	mount /dev/mmcblk1p2 /mnt/
elif [[ "$BOARD" == *"tasv8mp"* ]]; then                                                   
	mount /dev/mmcblk1p2 /mnt/
else                                                                                       
        echo "Error: board ${BOARD} not found."                                            
        exit 1                                                                             
fi

mount /dev/mmcblk2p2 /mnt2/
cp -ax /mnt/* /mnt2/
sync
umount /mnt
umount /mnt2

if [[ "$BOARD" == *"tasd8mm"* ]]; then                                                     
        mount /dev/mmcblk0p1 /mnt/                                                         
elif [[ "$BOARD" == *"tasd8mp"* ]]; then                                                   
        mount /dev/mmcblk1p1 /mnt/                                                         
elif [[ "$BOARD" == *"tasc8mp"* ]]; then                                                   
        mount /dev/mmcblk1p1 /mnt/                                                         
elif [[ "$BOARD" == *"tasv8mp"* ]]; then                                                   
        mount /dev/mmcblk1p1 /mnt/                                                         
else                                                                                       
        echo "Error: board ${BOARD} not found."                                            
        exit 1                                                                             
fi  

mount /dev/mmcblk2p1 /mnt2/
cp /mnt/* /mnt2/
sync
umount /mnt
umount /mnt2
rm -rf /mnt2

echo ""
echo "#####################################################################"
echo "#                                                                   #"
echo "#                              Done!                                #"
echo "#                                                                   #"
echo "#####################################################################"
echo ""
